/***************************************************************************
                          kmessedwords.h  -  description
                             -------------------
    begin                : Thu Jul 19 00:06:05 CEST 2001
    copyright            : (C) 2001 by Primoz Anzur (zer0Kode)
    email                : zerokode@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KMESSEDWORDS_H
#define KMESSEDWORDS_H
#define LOCAL_VERSION "1.0.0"
#define SILLY_CODENAME "World's peace"

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <kapp.h>
#include <qwidget.h>
#include <frontend.h>
#include <qbutton.h>
#include <qlabel.h>
#include <qcombobox.h>
#include <qlineedit.h>
#include <time.h>
#include <stdlib.h>
#include <stdio.h>
#include <kmessagebox.h>
#include <krandomsequence.h>
#include <qlist.h>
#include <qpushbutton.h>
#include <kpopupmenu.h>
#include <kstddirs.h>
#include <klocale.h>
#include <kconfig.h>

#include "kwritewords.h"
#include "scores.h"
#include "klogin.h"

/** KMessedWords is the base class of the project */
class KMessedWords : public FrontEnd
{
  Q_OBJECT 
public:
    /** construtor */
    KMessedWords(QWidget* parent=0, const char *name=0);
    /** destructor */
    ~KMessedWords();

    void randomizer(int level);
    void confuse_words();
    void reloadStructure();
	 KLogin getProceedingData;
	
    KLogin showLoginScreen;     //This is NEEDED for SINGLE instance of the window...
    QString shareLoginName;

public slots:
    virtual void slot_close();
    virtual void slot_messup();
    virtual void slot_try();
    virtual void slot_helpme();
    virtual void slot_textAccel();
    virtual void slot_openBook();
    virtual void slot_scores();
    virtual void slot_changeLevel();

protected:
    QString messedWord;
    QString cleanWord;
    QString guessedString;
	 QString setLocalDictionary;
    int guesses;
    int tGuesses; //t stands for total
    KRandomSequence random;
    KWriteWords showConfig;
    KWriteWords configInputData;
    HighScores showScores;
    int lines;
    int messups;
    int solvedWords;
  	 QString kMessedDataDir;
    QString kMessedPicturesDir;
	 KConfig *config;	
	 QString readName[10];
	 int readSolved[10];
	 int readRounds[10];
	 int readTotal[10];
	 int readGuesses[10];
	 QString varrounds;
	 QString varnames;
	 QString varsolved;
	 QString vartotal;
	 QString varguesses;
    QString justtext;	
    KPopupMenu *helpMenu;
	
protected slots:
	 void write_scores();
	 void read_scores();
	 void first_run();
	 void check_update();
};

#endif
